const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const events = sequelize.define(
    'events',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

event_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"seasonal",


"challenge",


"community",


"reward_boost"

        ],

      },

starts_at: {
        type: DataTypes.DATE,
      
      

      },

ends_at: {
        type: DataTypes.DATE,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  events.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity



































    db.events.hasMany(db.leaderboard_entries, {
      as: 'leaderboard_entries_event',
      foreignKey: {
          name: 'eventId',
      },
      constraints: false,
    });



//end loop





    db.events.hasMany(db.file, {
      as: 'event_images',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.events.getTableName(),
        belongsToColumn: 'event_images',
      },
    });


    db.events.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.events.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return events;
};


